InvertibleRSAFunction Class Reference

RSA trapdoor function using the private key. More...

Inheritance diagram for InvertibleRSAFunction:

## Public Member Functions

void | Initialize (RandomNumberGenerator &rng, unsigned int modulusBits, const Integer &e=17)
| Create a RSA private key. More...
void | Initialize (const Integer &n, const Integer &e, const Integer &d, const Integer &p, const Integer &q, const Integer &dp, const Integer &dq, const Integer &u)
| Initialize a RSA private key with {n,e,d,p,q,dp,dq,u}. More...
void | Initialize (const Integer &n, const Integer &e, const Integer &d)
| Initialize a RSA private key with {n,e,d}. More...
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
void | Load (BufferedTransformation &bt)
| Loads a key from a BufferedTransformation. More...
void | Save (BufferedTransformation &bt) const
| Saves a key to a BufferedTransformation. More...
OID | GetAlgorithmID () const
| Retrieves the OID of the algorithm. More...
void | BERDecodePrivateKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| decode privateKey part of privateKeyInfo, without the OCTET STRING header
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| encode privateKey part of privateKeyInfo, without the OCTET STRING header
Integer | CalculateInverse (RandomNumberGenerator &rng, const Integer &x) const
| Calculates the inverse of an element. More...
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
const Integer & | GetPrime1 () const
const Integer & | GetPrime2 () const
const Integer & | GetPrivateExponent () const
const Integer & | GetModPrime1PrivateExponent () const
const Integer & | GetModPrime2PrivateExponent () const
const Integer & | GetMultiplicativeInverseOfPrime2ModPrime1 () const
void | SetPrime1 (const Integer &p)
void | SetPrime2 (const Integer &q)
void | SetPrivateExponent (const Integer &d)
void | SetModPrime1PrivateExponent (const Integer &dp)
void | SetModPrime2PrivateExponent (const Integer &dq)
void | SetMultiplicativeInverseOfPrime2ModPrime1 (const Integer &u)
Public Member Functions inherited from RSAFunction
void | Initialize (const Integer &n, const Integer &e)
| Initialize a RSA public key with {n,e}. More...
void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| decode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
void | DEREncodePublicKey (BufferedTransformation &bt) const
| encode subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header
Integer | ApplyFunction (const Integer &x) const
| Applies the trapdoor. More...
Integer | PreimageBound () const
| Returns the maximum size of a message before the trapdoor function is applied. More...
Integer | ImageBound () const
| Returns the maximum size of a message after the trapdoor function is applied. More...
const Integer & | GetModulus () const
const Integer & | GetPublicExponent () const
void | SetModulus (const Integer &n)
void | SetPublicExponent (const Integer &e)
Public Member Functions inherited from TrapdoorFunction
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
| Applies the trapdoor function. More...
bool | IsRandomized () const
| Determines if the encryption algorithm is randomized. More...
Public Member Functions inherited from TrapdoorFunctionBounds
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key. More...
virtual Integer | MaxImage () const
| Returns the maximum size of a message after the trapdoor function is applied bound to a public key. More...
Public Member Functions inherited from X509PublicKey
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
Public Member Functions inherited from ASN1CryptoMaterial< PublicKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
virtual void | Precompute (unsigned int precomputationStorage)
| Perform precomputation. More...
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...
Public Member Functions inherited from TrapdoorFunctionInverse
Integer | CalculateRandomizedInverse (RandomNumberGenerator &rng, const Integer &x) const
| Applies the inverse of the trapdoor function. More...
bool | IsRandomized () const
| Determines if the decryption algorithm is randomized. More...
Public Member Functions inherited from PKCS8PrivateKey
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
virtual void | BERDecodeOptionalAttributes (BufferedTransformation &bt)
| decode optional attributes including context-specific tag More...
virtual void | DEREncodeOptionalAttributes (BufferedTransformation &bt) const
| encode optional attributes including context-specific tag
Public Member Functions inherited from ASN1CryptoMaterial< PrivateKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters. More...

## Additional Inherited Members

Static Public Member Functions inherited from NameValuePairs
static void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

RSA trapdoor function using the private key.

Definition at line 62 of file rsa.h.

## Member Function Documentation

## Initialize() [1/3]

void InvertibleRSAFunction::Initialize | ( | RandomNumberGenerator & | rng,
|  | unsigned int | modulusBits,
|  | const Integer & | e = `17`
| ) |  |

Create a RSA private key.

Parameters

  rng | a RandomNumberGenerator derived class
  modulusBits | the size of the modulud, in bits
  e | the desired public exponent

Definition at line 147 of file rsa.cpp.

## Initialize() [2/3]

void InvertibleRSAFunction::Initialize | ( | const Integer & | n,
|  | const Integer & | e,
|  | const Integer & | d,
|  | const Integer & | p,
|  | const Integer & | q,
|  | const Integer & | dp,
|  | const Integer & | dq,
|  | const Integer & | u
| ) |  |

inline

Initialize a RSA private key with {n,e,d,p,q,dp,dq,u}.

Parameters

  n | modulus
  e | public exponent
  d | private exponent
  p | first prime factor
  q | second prime factor
  dp | d mod p
  dq | d mod q
  u | q-1 mod p

Definition at line 82 of file rsa.h.

## Initialize() [3/3]

void InvertibleRSAFunction::Initialize | ( | const Integer & | n,
|  | const Integer & | e,
|  | const Integer & | d
| ) |  |

Initialize a RSA private key with {n,e,d}.

Parameters

  n | modulus
  e | public exponent
  d | private exponent

Initialize() will factor n using d and populate {p,q,dp,dq,u}.

Definition at line 152 of file rsa.cpp.

## BERDecode()

void InvertibleRSAFunction::BERDecode | ( | BufferedTransformation & | bt | ) |

inline virtual

Decode this object from a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER)

Reimplemented from PKCS8PrivateKey.

Definition at line 92 of file rsa.h.

## DEREncode()

void InvertibleRSAFunction::DEREncode | ( | BufferedTransformation & | bt | ) | const

inline virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Distinguished Encoding Rules (DER)

Reimplemented from PKCS8PrivateKey.

Definition at line 94 of file rsa.h.

## Load()

void InvertibleRSAFunction::Load | ( | BufferedTransformation & | bt | ) |

inline virtual

Loads a key from a BufferedTransformation.

Parameters

  bt | the source BufferedTransformation

Exceptions

  KeyingErr |

Load() attempts to read material from a BufferedTransformation. If the material is a key that was generated outside the library, then the following usually applies:

- the key should be ASN.1 BER encoded
- the key should be a "key info"

"key info" means the key should have an object identifier with an algorthm id, like a subjectPublicKeyInfo.

To read a "raw" key without the "key info", then call the key's BERDecode() method.

Note
  Load generally does not check that the key is valid. Call Validate(), if needed.

Reimplemented from CryptoMaterial.

Definition at line 96 of file rsa.h.

## Save()

void InvertibleRSAFunction::Save | ( | BufferedTransformation & | bt | ) | const

inline virtual

Saves a key to a BufferedTransformation.

Parameters

  bt | the destination BufferedTransformation

Exceptions

  NotImplemented |

Save() writes the material to a BufferedTransformation.

If the material is a key, then the key is written with ASN.1 DER encoding. The key includes an object identifier with an algorthm id, like a subjectPublicKeyInfo.

A "raw" key without the "key info" can be saved using a key's DEREncode() method.

If a derived class does not override Save(), then the base class throws NotImplemented().

Reimplemented from CryptoMaterial.

Definition at line 98 of file rsa.h.

## GetAlgorithmID()

OID InvertibleRSAFunction::GetAlgorithmID | ( |  | ) | const

inline virtual

Retrieves the OID of the algorithm.

Returns
  OID of the algorithm

Implements PKCS8PrivateKey.

Definition at line 100 of file rsa.h.

## CalculateInverse()

Integer InvertibleRSAFunction::CalculateInverse | ( | RandomNumberGenerator & | rng,
|  | const Integer & | x
| ) |  | const

virtual

Calculates the inverse of an element.

Parameters

  rng | a `RandomNumberGenerator` derived class
  x | the element

Returns
  the inverse of the element in the group

Implements TrapdoorFunctionInverse.

Reimplemented in InvertibleRSAFunction_ISO.

Definition at line 227 of file rsa.cpp.

## Validate()

bool InvertibleRSAFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const

virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Reimplemented from RSAFunction.

Definition at line 247 of file rsa.cpp.

## GenerateRandom()

void InvertibleRSAFunction::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) |  |

virtual

parameters: (ModulusSize, PublicExponent (default 17))

Reimplemented from GeneratableCryptoMaterial.

Definition at line 106 of file rsa.cpp.

## GetVoidValue()

bool InvertibleRSAFunction::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const

virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrives the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Reimplemented from RSAFunction.

Definition at line 268 of file rsa.cpp.

## AssignFrom()

void InvertibleRSAFunction::AssignFrom | ( | const NameValuePairs & | source | ) |

virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Reimplemented from RSAFunction.

Definition at line 280 of file rsa.cpp.

The documentation for this class was generated from the following files:

- rsa.h
- rsa.cpp